local plscript = CreateFrame("Frame")
plscript:RegisterEvent("PLAYER_ENTERING_WORLD", unit)
plscript:RegisterEvent("ADDON_LOADED")
local function eventHandler(self,event)
	if event == "ADDON_LOADED" then
		if (arenaX == nil) then
				playerX, playerY, targetX, targetY, focusX, focusY, arenaX, arenaY = -475, 175, -250, 175, 250, 175, 350, 50
				hideMacro = false
				print("PowerInterface version 2.0 loaded for the first time.\nUse |cFF00FF00/pui |ror |cFF00FF00/powerui |rto get started.\nThank You for downloading! ~TheBackstabi")
		end
	end		
	if event == "PLAYER_ENTERING_WORLD" then
				-- FRAMES
				PlayerFrame:ClearAllPoints()
				PlayerFrame:SetPoint("CENTER", playerX, playerY)
				TargetFrame:ClearAllPoints()
				TargetFrame:SetPoint("CENTER", targetX, targetY)
				FocusFrame:ClearAllPoints()
				FocusFrame:SetPoint("CENTER", focusX, focusY)
				
				-- CLASS PORTRAITS
				UFP = "UnitFramePortrait_Update"
				UICC = "Interface\\TargetingFrame\\UI-Classes-Circles"
				CIT = CLASS_ICON_TCOORDS
				hooksecurefunc(UFP,function(self) if self.portrait then local t = CIT[select(2,UnitClass(self.unit))] if t then self.portrait:SetTexture(UICC) self.portrait:SetTexCoord(unpack(t)) end end end)
				
				-- BARS
					-- Hides macro text
				if hideMacro == true then
					for i=1,12 do _G["ActionButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomLeftButton"..i.."Name"]:SetAlpha(0) _G["MultiBarRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarLeftButton"..i.."Name"]:SetAlpha(0) end
				end
				
					-- Hiding unnecessary things
				SpellActivationOverlayFrame:SetScale(.6)
				ActionBarUpButton:SetAlpha(0)
				ActionBarDownButton:SetAlpha(0)
				MainMenuBarPageNumber:SetAlpha(0)
				MainMenuBarLeftEndCap:SetAlpha(0)
				MainMenuBarRightEndCap:SetAlpha(0)
				UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
				MainMenuBarMaxLevelBar:SetAlpha(0)
				for i=0,3 do _G["MainMenuBarTexture"..i]:SetAlpha(0)end
				for i=0,3 do _G["MainMenuMaxLevelBar"..i]:SetAlpha(0)end
				
					-- Fix for frame auras
				TargetFrameToT:ClearAllPoints()
				TargetFrameToT:SetPoint("BOTTOMRIGHT",TargetFrame,-15,-10)
				FocusFrameToT:ClearAllPoints()
				FocusFrameToT:SetPoint("BOTTOMRIGHT",FocusFrame,-15,-10)
				
					-- Sexy Chat Frame
				for i=1,4 do _G["ChatFrame"..i]:SetFont("Fonts\\ARIALN.TTF",15,"OUTLINE")end
				
				MainMenuBar:ClearAllPoints()
				MainMenuBar:SetPoint("BOTTOMRIGHT",2,35)
				MainMenuBar.SetPoint = function() end
				
				MultiBarBottomLeftButton1:ClearAllPoints()
				MultiBarBottomLeftButton1:SetPoint("BOTTOM", ActionButton1, "TOP", 0, 7)
				MultiBarBottomLeftButton1.SetPoint = function() end
				
				MultiBarBottomRightButton1:ClearAllPoints()
				MultiBarBottomRightButton1:SetPoint("BOTTOM",MultiBarBottomLeftButton1,"TOP",0,7)
				MultiBarBottomRightButton1.SetPoint = function() end
				
					-- Pet Bars
				PetActionButton1:ClearAllPoints()
				PetActionButton1:SetPoint("BOTTOM", MultiBarBottomRightButton3, "TOP", -25, 7)
				PetActionButton1.SetPoint = function() end
				
					-- Stance Bars
				StanceBarFrame:ClearAllPoints()
				StanceBarFrame:SetPoint("BOTTOM", PetActionButton1, "TOP", 0, 7)
				StanceBarFrame.SetPoint = function() end
				
					-- Exp and Rep bars
				MainMenuExpBar:ClearAllPoints()
				MainMenuExpBar:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 0)
				ReputationWatchBar:ClearAllPoints()
				ReputationWatchBar:SetPoint("BOTTOM", MainMenuExpBar, "TOP", 0, 3)
				ReputationWatchBar.SetPoint = function() end --Required because bar moves on its own sometimes
				
					-- Red icons for out of range
				hooksecurefunc("ActionButton_OnEvent",function(self, event, ...)
                                if ( event == "PLAYER_TARGET_CHANGED" ) then
                                                self.newTimer = self.rangeTimer
                                end
                end)

                hooksecurefunc("ActionButton_UpdateUsable",function(self)
                                local icon = _G[self:GetName().."Icon"]
                                local valid = IsActionInRange(self.action)

                                if ( valid == 0 ) then
                                                icon:SetVertexColor(1.0, 0.1, 0.1) -- SetAlpha(0.3)SetVertexColor(1.0, 0.1, 0.1)
                                end
                end)

                hooksecurefunc("ActionButton_OnUpdate",function(self, elapsed)
                                local rangeTimer = self.newTimer

                                if ( rangeTimer ) then
                                                rangeTimer = rangeTimer - elapsed
 
                                                if ( rangeTimer <= 0 ) then
                                                                ActionButton_UpdateUsable(self)
                                                                rangeTimer = TOOLTIP_UPDATE_TIME
                                                end

                                                self.newTimer = rangeTimer
                                end
                end)
				
					-- Cast bar
				CastingBarFrame:HookScript("OnShow", function(self)
							self:ClearAllPoints()
							self:SetPoint("CENTER", UIParent, "CENTER", 0, -150)
				end)

				CastingBarFrame.timer = CastingBarFrame:CreateFontString(nil);
				CastingBarFrame.timer:SetFont(STANDARD_TEXT_FONT,12,"OUTLINE");
				CastingBarFrame.timer:SetPoint("BOTTOM", CastingBarFrame, "TOP", 0, 5);
				CastingBarFrame.update = .1;

				hooksecurefunc("CastingBarFrame_OnUpdate", function(self, elapsed)
						if not self.timer then return end
						if self.update and self.update < elapsed then
								if self.casting then
										self.timer:SetText(format("%2.1f/%1.1f", max(self.maxValue - self.value, 0), self.maxValue))
								elseif self.channeling then
										self.timer:SetText(format("%.1f", max(self.value, 0)))
								else
										self.timer:SetText("")
								end
								self.update = .1
						else
								self.update = self.update - elapsed
						end
				end)
				
				-- HIDE PET DAMAGE PORTRAIT
				PlayerHitIndicator:SetText(nil)
				PlayerHitIndicator.SetText = function() end

				PetHitIndicator:SetText(nil)
				PetHitIndicator.SetText = function() end
				
				-- SCROLLABLE MINIMAP (HIDES +/- BUTTONS)
				MinimapZoomIn:Hide()
				MinimapZoomOut:Hide()
				Minimap:EnableMouseWheel(true)
				Minimap:SetScript('OnMouseWheel', function(self, delta)
						if delta > 0 then
								Minimap_ZoomIn()
						else
								Minimap_ZoomOut()
						end
				end)
				MiniMapTracking:ClearAllPoints()
				MiniMapTracking:SetPoint("TOPRIGHT", -26, 7)
	end
end
SLASH_POWERINTERFACE1, SLASH_POWERINTERFACE2 = '/powerui', '/pui';
local function handler(msg, editbox)
 local command, x, y = msg:match("^(%S*)%s*(-?%d+),(-?%d+)$")
  if msg == "defaults" then
   playerX, playerY, targetX, targetY, focusX, focusY, arenaX, arenaY = -475, 175, -250, 175, 250, 175, 350, 50
   PlayerFrame:ClearAllPoints()
   PlayerFrame:SetPoint("CENTER", playerX, playerY)
   TargetFrame:ClearAllPoints()
   TargetFrame:SetPoint("CENTER", targetX, targetY)
   FocusFrame:ClearAllPoints()
   FocusFrame:SetPoint("CENTER", focusX, focusY)
   print("Frames moved to default positions. If you were moving arena frames, do a /reload.")
  elseif msg == "hidemacro" then
   if hideMacro == false then
    hideMacro = true
	for i=1,12 do _G["ActionButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomLeftButton"..i.."Name"]:SetAlpha(0) _G["MultiBarRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarLeftButton"..i.."Name"]:SetAlpha(0) end
   else
    hideMacro = false
	for i=1,12 do _G["ActionButton"..i.."Name"]:SetAlpha(1) _G["MultiBarBottomRightButton"..i.."Name"]:SetAlpha(1) _G["MultiBarBottomLeftButton"..i.."Name"]:SetAlpha(1) _G["MultiBarRightButton"..i.."Name"]:SetAlpha(1) _G["MultiBarLeftButton"..i.."Name"]:SetAlpha(1) end
  end
  elseif command == "player" and x ~= "" and y ~= "" then
  x, y = tonumber(x), tonumber(y)
   playerX, playerY = x, y;
   PlayerFrame:ClearAllPoints();
   PlayerFrame:SetPoint("CENTER", playerX, playerY);
   print("PlayerFrame position moved");
  elseif command == "target" and x ~= "" and y ~= "" then
  x, y = tonumber(x), tonumber(y)
   targetX, targetY = x, y;
   TargetFrame:ClearAllPoints();
   TargetFrame:SetPoint("CENTER", targetX, targetY);
   print("TargetFrame position moved");
  elseif command == "focus" and x ~= "" and y ~= "" then
  x, y = tonumber(x), tonumber(y)
   focusX, focusY = x, y;
   FocusFrame:ClearAllPoints();
   FocusFrame:SetPoint("CENTER", focusX, focusY);
   print("FocusFrame position moved");
  elseif command == "arena" and x ~= "" and y ~= "" then
   x, y = tonumber(x), tonumber(y)
   -- PLACEHOLDER TEXT BECAUSE I'M BLIND AS A BAT
    arenaX, arenaY = x, y;
	if not IsAddOnLoaded("Blizzard_ArenaUI") then
         LoadAddOn("Blizzard_ArenaUI")
     end
     ArenaEnemyFrames:Show()
	 for i=1,5 do _G["ArenaEnemyFrame"..i]:Show()_G["ArenaEnemyFrame"..i.."CastingBar"]:Show()end--_G["ArenaEnemyFrame"..i.."PetFrame"]:Show()end
     local arenaFrame
     for i = 1, 5 do
         arenaFrame = _G["ArenaEnemyFrame"..i]		
         arenaFrame.classPortrait:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
         arenaFrame.classPortrait:SetTexCoord(unpack(CLASS_ICON_TCOORDS["WARRIOR"]))
         arenaFrame.name:SetText("Dispelme")
         arenaFrame:Show()        			
     end
	 
	ArenaEnemyFrame1:ClearAllPoints()
	ArenaEnemyFrame2:ClearAllPoints()
	ArenaEnemyFrame3:ClearAllPoints()
	ArenaEnemyFrame4:ClearAllPoints()
	ArenaEnemyFrame5:ClearAllPoints()

	ArenaEnemyFrame1:SetPoint("CENTER",UIParent,"CENTER",arenaX,arenaY)
	ArenaEnemyFrame2:SetPoint("CENTER",UIParent,"CENTER",arenaX,arenaY-50)
	ArenaEnemyFrame3:SetPoint("CENTER",UIParent,"CENTER",arenaX,arenaY-100)
	ArenaEnemyFrame4:SetPoint("CENTER",UIParent,"CENTER",arenaX,arenaY-150)
	ArenaEnemyFrame5:SetPoint("CENTER",UIParent,"CENTER",arenaX,arenaY-200)

	ArenaEnemyFrame1.SetPoint = function() end
	ArenaEnemyFrame2.SetPoint = function() end
	ArenaEnemyFrame3.SetPoint = function() end
	ArenaEnemyFrame4.SetPoint = function() end
	ArenaEnemyFrame5.SetPoint = function() end
	
	ArenaEnemyFrames:SetScale(1.3)
    print("ArenaFrame position moved. Once finished, do a /reload. Defaults are 350,50.");
   else
	 print("PowerInterface commands: |cFF00FF00/pui |ror |cFF00FF00/powerui |cFFFF0000(Everything is case-sensitive!)|r\ndefaults |cFF00FF00\n--- Sets all frames to default PowerInterface locations.\n|rplayer | target | focus | arena x,y\n|cFF00FF00--- Locks frame to x (horizontal) and y (vertical) ordered pair. 0,0 is the center of your screen.\n|rhidemacro\n|cFF00FF00 --- Hides/Shows macro text on hotkeys.\n|rFound a bug? Want a feature? Go to the WoWInterface or Curse page!")
   end
end
SlashCmdList["POWERINTERFACE"] = handler;
plscript:SetScript("OnEvent",eventHandler)
